"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const resolve_1 = require("./resolve");
exports.addResolutionAttribute = (options, fileName, resolveOptions) => {
    return (dependency) => {
        const attributes = resolve_1.resolve(dependency, options.baseDir, path.dirname(fileName), resolveOptions);
        return {
            module: dependency.moduleName,
            moduleSystem: dependency.moduleSystem,
            resolved: attributes.resolved,
            coreModule: attributes.coreModule,
            followable: attributes.followable,
            dependencyTypes: attributes.dependencyTypes,
            couldNotResolve: attributes.couldNotResolve,
            matchesDoNotFollow: false,
        };
    };
};
