"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enhancedResolve = require("enhanced-resolve");
const cachedResolver = {};
const createResolver = (option, cacheContext) => {
    if (!cachedResolver[cacheContext]) {
        return (cachedResolver[cacheContext] = enhancedResolve.ResolverFactory.createResolver({
            ...option,
            symlinks: false,
        }));
    }
    return cachedResolver[cacheContext];
};
exports.resolve = (moduleName, fileDir, option, cacheContext = "code-dependency") => {
    const resolver = createResolver(option, cacheContext);
    return resolver.resolveSync({}, fileDir, moduleName);
};
