"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const resolved_commonjs_1 = require("./resolved-commonjs");
const resolveOptions_1 = require("./resolveOptions");
const isRelativeModuleName = (pString) => pString.startsWith(".");
const resolveModule = (dependency, baseDir, fileDir, resolveOption) => {
    if (isRelativeModuleName(dependency.moduleName) || dependency.moduleSystem in ["cjs", "es6"]) {
        return resolved_commonjs_1.resolveCommonJS(dependency.moduleName, baseDir, fileDir, resolveOption);
    }
    else {
        return resolved_commonjs_1.resolveCommonJS(dependency.moduleName, baseDir, fileDir, resolveOption);
    }
};
exports.resolve = (dependency, baseDir, fileDir, option) => {
    const resolveOption = resolveOptions_1.compileResolveOptions(option);
    const resolvedModule = resolveModule(dependency, baseDir, fileDir, resolveOption);
    if (!resolvedModule.coreModule && !resolvedModule.couldNotResolve && resolvedModule.resolved) {
        try {
            const resolvedPath = path.resolve(baseDir, fs.realpathSync(path.resolve(baseDir, resolvedModule.resolved)));
            resolvedModule.resolved = path.normalize(resolvedPath);
        }
        catch (e) {
            resolvedModule.couldNotResolve = true;
        }
    }
    return resolvedModule;
};
