"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enhancedResolve = require("enhanced-resolve");
const PnpWebpackPlugin = require("pnp-webpack-plugin");
const TsConfigPathsPlugin = require("tsconfig-paths-webpack-plugin");
const CACHE_DURATION = 4000;
exports.compileResolveOptions = (option, extraOption = {}) => {
    const DEFAULT_RESOLVE_OPTIONS = {
        symlinks: false,
        extensions: [".js"],
    };
    const NON_OVERRIDABLE_RESOLVE_OPTIONS = {
        fileSystem: new enhancedResolve.CachedInputFileSystem(new enhancedResolve.NodeJsInputFileSystem(), CACHE_DURATION),
        useSyncFileSystemCalls: true,
    };
    const plugins = [];
    if (extraOption.tsConfig) {
        plugins.push(new TsConfigPathsPlugin({ configFile: extraOption.tsConfig }));
    }
    if (extraOption.externalModuleResolutionStrategy === "yarn-pnp") {
        plugins.push(PnpWebpackPlugin);
    }
    return { ...DEFAULT_RESOLVE_OPTIONS, ...{ plugins }, ...option, ...NON_OVERRIDABLE_RESOLVE_OPTIONS };
};
