"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const resolve_1 = require("resolve");
const enhancedResolve_1 = require("./enhancedResolve");
function addResolutionAttributes(baseDir, moduleName, fileDir, resolveOption) {
    let resolved;
    let followable = false;
    let couldNotResolve = false;
    let coreModule = false;
    if (resolve_1.isCore(moduleName)) {
        coreModule = true;
    }
    else {
        try {
            resolved = path.relative(baseDir, enhancedResolve_1.resolve(moduleName, fileDir, resolveOption));
            followable = true;
        }
        catch (e) {
            couldNotResolve = true;
        }
    }
    return {
        resolved,
        followable,
        couldNotResolve,
        coreModule,
        dependencyTypes: ["undetermined"],
    };
}
exports.resolveCommonJS = (moduleName, baseDir, fileDir, option) => {
    return addResolutionAttributes(baseDir, moduleName, fileDir, option);
};
